import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { AppRenew, AppRenewParam } from '@/api/oa/app/renew/model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询开发成员
 */
export async function pageAppRenew(params: AppRenewParam) {
  const res = await request.get<ApiResult<PageResult<AppRenew>>>(
    MODULES_API_URL + '/oa/app-renew/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询开发成员列表
 */
export async function listAppRenew(params?: AppRenewParam) {
  const res = await request.get<ApiResult<AppRenew[]>>(
    MODULES_API_URL + '/oa/app-renew',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询开发成员
 */
export async function getAppRenew(id: number) {
  const res = await request.get<ApiResult<AppRenew>>(
    MODULES_API_URL + '/oa/app-renew/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加开发成员
 */
export async function addAppRenew(data: AppRenew) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-renew',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改开发成员
 */
export async function updateAppRenew(data: AppRenew) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-renew',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除开发成员
 */
export async function removeAppRenew(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-renew/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除开发成员
 */
export async function removeBatchAppRenew(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-renew/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-renew/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
